/// <reference types="node" />
import * as Metadata from "userscript-metadata";
import { Mode } from "./mode";
export declare const HOSTED_AT_EXAMPLE = "https://example.com/userscripts";
export declare type BuildConfig = Readonly<{
    allowJs: boolean;
    id: string;
    hostedAt: string | null;
    mainFile: string;
    mode: Mode;
    nightly: boolean;
    now: Date;
    outDir: string;
    rootDir: string;
    sassVariableGetter: string;
    sassVariables: object;
    sourceDir: string;
    verbose: boolean;
}>;
export declare type WebpackConfigParameters = Readonly<{
    buildConfig: BuildConfig;
    metadata: (buildConfig: BuildConfig) => Metadata.Metadata;
    metadataSchema: Metadata.ValidateOptions;
    env: NodeJS.ProcessEnv;
}>;
export declare type EnvVarError = Readonly<{
    fullName: string;
    expected: string | readonly string[];
    found: string;
}>;
export declare type BuildConfigAndListOf<E> = Readonly<{
    buildConfig: BuildConfig;
    errors: readonly E[];
}>;
declare type DistFileType = "user" | "meta";
export declare function distFileName(id: string, type: DistFileType): string;
export declare function metadataUrl(hostedAt: string, id: string, type: DistFileType): string;
export declare function envVars(env: NodeJS.ProcessEnv): (readonly [string, string | undefined])[];
export declare function overrideBuildConfig(buildConfig: BuildConfig, env: NodeJS.ProcessEnv): BuildConfigAndListOf<EnvVarError>;
export {};
