"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const log = __importStar(require("./log"));
const operations = __importStar(require("./operations"));
const stylesheets = __importStar(require("./stylesheets"));
function run(userscript) {
    log.setPrefix(`[${userscript.name}]`);
    const attr = attribute(userscript.id);
    if (document.documentElement.hasAttribute(attr)) {
        log.warning(`It looks as though ${userscript.name} has already run (because the attribute "${attr}" was found on <head>). Stopping.`);
    }
    else {
        document.documentElement.setAttribute(attr, "");
        userscript.initialAction();
        stylesheets.insert(userscript.stylesheets);
        operations.run(userscript.operationsPlan);
    }
}
exports.run = run;
function attribute(id) {
    return "data-" + id + "-has-run";
}
